/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

PtFrN function [PASS_TOTAL] [2] [LAST_TOKEN];

pass_init ()
{
	pass_init_set_to_null ();

	check_pass_init ();
	trans_pass_init ();
        /** BOZKUS **/
        comm_pass_init  ();
        /** END **/
	write_pass_init ();
}

check_pass_init ()
{
/* ##BEG## 9/24/91, SHU */
	function [PASS_CHECK] [PASS_UP] [DIRECTIVE_STMT] = check_DirectiveStmt;
/* ##END## */

	function [PASS_CHECK] [PASS_DOWN] [STATEMENT] = check_Statement_down;

	function [PASS_CHECK] [PASS_UP] [STATEMENT] = check_Statement;

	function [PASS_CHECK] [PASS_UP] [END_PROGRAM_STMT] = check_EndProgramStmt;
	function [PASS_CHECK] [PASS_UP] [END_SUBROUTINE_STMT] = check_EndSubroutineStmt;
	function [PASS_CHECK] [PASS_UP] [END_FUNCTION_STMT] = check_EndFunctionStmt;
/*
	function [PASS_CHECK] [PASS_UP] [MODULE_STMT] = check_ModuleStmt;
*/
	function [PASS_CHECK] [PASS_UP] [END_MODULE_STMT] = check_EndModuleStmt;
	function [PASS_CHECK] [PASS_UP] [END_BLOCK_DATA_STMT] = check_EndBlockDataStmt;

	function [PASS_CHECK] [PASS_DOWN] [FORALL_STMT] = check_ForallStmt_down;
	function [PASS_CHECK] [PASS_UP] [FORALL_STMT] = check_ForallStmt;
	function [PASS_CHECK] [PASS_UP] [WHERE_STMT] = check_WhereStmt;
	function [PASS_CHECK] [PASS_UP] [WHERE_CONSTRUCT_STMT] = check_WhereConstructStmt;
	function [PASS_CHECK] [PASS_UP] [ELSEWHERE_STMT] = check_ElsewhereStmt;
	function [PASS_CHECK] [PASS_UP] [END_WHERE_STMT] = check_EndWhereStmt;

	function [PASS_CHECK] [PASS_UP] [INTENT_STMT] = check_IntentStmt;

	function [PASS_CHECK] [PASS_UP] [IF_STMT] = check_IfStmt;
	function [PASS_CHECK] [PASS_UP] [IF_THEN_STMT] = check_IfThenStmt;
	function [PASS_CHECK] [PASS_UP] [ELSE_IF_STMT] = check_ElseIfStmt;
	function [PASS_CHECK] [PASS_UP] [ELSE_STMT] = check_ElseStmt;
	function [PASS_CHECK] [PASS_UP] [END_IF_STMT] = check_EndIfStmt;

	function [PASS_CHECK] [PASS_UP] [SELECT_CASE_STMT] = check_SelectCaseStmt;
	function [PASS_CHECK] [PASS_UP] [CASE_STMT] = check_CaseStmt;
	function [PASS_CHECK] [PASS_UP] [END_SELECT_STMT] = check_EndSelectStmt;

	function [0] [PASS_UP] [ARRAY_CONSTRUCTOR] = parse_ArrayConstructor;

	function [PASS_CHECK] [PASS_UP] [OPEN_STMT] = check_OpenStmt;
	function [PASS_CHECK] [PASS_UP] [CLOSE_STMT] = check_CloseStmt;
	function [PASS_CHECK] [PASS_UP] [WRITE_STMT] = check_WriteStmt;
	function [PASS_CHECK] [PASS_UP] [READ_STMT] = check_ReadStmt;
	function [PASS_CHECK] [PASS_UP] [PRINT_STMT] = check_PrintStmt;
	function [PASS_CHECK] [PASS_UP] [BACKSPACE_STMT] = check_BackspaceStmt;
	function [PASS_CHECK] [PASS_UP] [END_FILE_STMT] = check_EndFileStmt;
	function [PASS_CHECK] [PASS_UP] [REWIND_STMT] = check_RewindStmt;
	function [PASS_CHECK] [PASS_UP] [INQUIRE_STMT] = check_InquireStmt;
	function [PASS_CHECK] [PASS_UP] [ATTR_SPEC] = check_AttrSpec;
	function [PASS_CHECK] [PASS_UP] [COMPLEX_LITERAL_CONSTANT] = check_ComplexLiteralConstant;

	function [PASS_CHECK] [PASS_UP] [DO_STMT] = check_DoStmt;
	function [PASS_CHECK] [PASS_UP] [END_DO_STMT] = check_EndDoStmt;
	function [PASS_CHECK] [PASS_UP] [EXIT_STMT] = check_ExitStmt;
	function [PASS_CHECK] [PASS_UP] [CYCLE_STMT] = check_CycleStmt;

	function [PASS_CHECK] [PASS_DOWN] [STRIDE] = parse_Stride_down;

	function [0] [PASS_DOWN] [IMPLIED_DO] = parse_ImpliedDo_down;

	function [0] [PASS_UP] [ASSIGNEMENT_STMT] = parse_AssignementStmt;
	function [0] [PASS_UP] [TYPE_DECLARATION_STMT] = parse_TypeDeclarationStmt;
	function [0] [PASS_UP] [ENTITY_DECL_1] = parse_EntityDecl1;
	function [0] [PASS_UP] [ENTITY_DECL] = parse_EntityDecl;
	function [0] [PASS_UP] [IMPLIED_DO_CONTROL] = parse_ImpliedDoControl;
	function [0] [PASS_UP] [NAMED_CONSTANT_DEF] = parse_NamedConstantDef;
	function [0] [PASS_UP] [VARIABLE] = parse_Variable;

/* broke next 2 along ArraySection */

	function [0] [PASS_DOWN] [EQUIVALENCE_STMT] = parse_EquivalenceStmt_down;
	function [0] [PASS_UP] [EQUIVALENCE_STMT] = parse_EquivalenceStmt;

	function [0] [PASS_UP] [ARRAY_SECTION] = parse_ArraySection;
	function [0] [PASS_UP] [INTRINSIC_STMT] = parse_IntrinsicStmt;
	function [0] [PASS_UP] [EXTERNAL_STMT] = parse_ExternalStmt;
	function [0] [PASS_UP] [CALL_STMT] = parse_CallStmt;
	function [0] [PASS_UP] [FUNCTION_STMT] = parse_FunctionStmt;
	function [0] [PASS_UP] [SUBROUTINE_STMT] = parse_SubroutineStmt;
	function [0] [PASS_UP] [DUM_EXPR] = parse_DumExpr;
	function [0] [PASS_UP] [PRIMARY] = parse_Primary;
}

trans_pass_init ()
{
	function [PASS_TRANS] [PASS_UP] [WHERE_STMT] = trans_WhereStmt;
	function [PASS_TRANS] [PASS_UP] [PRINT_STMT] = trans_PrintStmt;
	function [PASS_TRANS] [PASS_UP] [WRITE_STMT] = trans_WriteStmt;
	function [PASS_TRANS] [PASS_UP] [READ_STMT] = trans_ReadStmt;

	function [PASS_TRANS] [PASS_UP] [INTENT_STMT] = trans_IntentStmt;
}

write_pass_init ()
{
	int i;

	for (i = 0; i < LAST_TOKEN; i++)
		function [PASS_WRITE] [PASS_DOWN] [i] = (PtFrN) write_default;

/* ##BEG## 9/24/91, SHU */
	/* we add special routine to write compiler dirctive
	   statements out */
/*	   function [PASS_WRITE] [PASS_DOWN] [DIRECTIVE_STMT] =   ZEKI*/
/*        Directive statement is written in write_default */
/* ##END## */

	function [PASS_WRITE] [PASS_DOWN] [INTERFACE_STMT] =
	function [PASS_WRITE] [PASS_DOWN] [END_INTERFACE_STMT] =
	function [PASS_WRITE] [PASS_DOWN] [INCLUDE_STMT] =
	function [PASS_WRITE] [PASS_DOWN] [SELECT_CASE_STMT] =
	function [PASS_WRITE] [PASS_DOWN] [CASE_STMT] =
	function [PASS_WRITE] [PASS_DOWN] [INTENT_STMT] =
	function [PASS_WRITE] [PASS_DOWN] [END_SELECT_STMT] = (PtFrN) 0;

	function [PASS_WRITE] [PASS_DOWN] [DATA] =
	function [PASS_WRITE] [PASS_DOWN] [READ] =
	function [PASS_WRITE] [PASS_DOWN] [WRITE] =
	function [PASS_WRITE] [PASS_DOWN] [PRINT] = (PtFrN) write_IOkeyword;

	function [PASS_WRITE] [PASS_DOWN] [TYPE_DECLARATION_STMT]
	 = (PtFrN) write_TypeDeclarationStmt;
	function [PASS_WRITE] [PASS_DOWN] [DUM_ARR_CONS] = (PtFrN) write_DumArrCons;
/* ##BEG##, 10/11/1991, ZEKI */
	function [PASS_WRITE] [PASS_DOWN] [FORALL_STMT] = (PtFrN) write_ForallStmt;

/* ##END##, 10/11/1991, ZEKI */
	function [PASS_WRITE] [PASS_DOWN] [SUBSCRIPT] = (PtFrN) write_Subscript;
	function [PASS_WRITE] [PASS_DOWN] [NAME] = (PtFrN) write_Name;

#ifdef CUBIX
	if (flag_cubix)
		function [PASS_WRITE] [PASS_DOWN] [STATEMENT] = (PtFrN) cubix_write_Statement;
	else
#endif
		function [PASS_WRITE] [PASS_DOWN] [STATEMENT] = (PtFrN) write_Statement;

	function [PASS_WRITE] [PASS_DOWN] [WHERE_STMT] = (PtFrN) write_WhereStmt;

	function [PASS_WRITE] [PASS_DOWN] [ASSIGNEMENT_STMT] = (PtFrN) write_AssignementStmt;
	function [PASS_WRITE] [PASS_DOWN] [STMT_FUNCTION_STMT] = (PtFrN) write_AssignementStmt;

	function [PASS_WRITE] [PASS_DOWN] [WHERE_CONSTRUCT] = (PtFrN) write_WhereConstruct;
	function [PASS_WRITE] [PASS_DOWN] [IF_CONSTRUCT] = (PtFrN) write_IfConstruct;
	function [PASS_WRITE] [PASS_DOWN] [IF_STMT] = (PtFrN) write_IfStmt;

	function [PASS_WRITE] [PASS_DOWN] [INTRINSIC_STMT] = (PtFrN) write_IntrinsicStmt;
	function [PASS_WRITE] [PASS_DOWN] [ENTRY_STMT] = (PtFrN) write_EntryStmt;
	function [PASS_WRITE] [PASS_DOWN] [FUNCTION_STMT] = (PtFrN) write_FunctionStmt;
	function [PASS_WRITE] [PASS_DOWN] [SUBROUTINE_STMT] = (PtFrN) write_SubroutineStmt;
	function [PASS_WRITE] [PASS_DOWN] [FUNCTION_REFERENCE]
	= (PtFrN) write_FunctionReference;
	function [PASS_WRITE] [PASS_DOWN] [CALL_STMT] = (PtFrN) write_CallStmt;
	function [PASS_WRITE] [PASS_DOWN] [ARRAY_SECTION] = (PtFrN) write_ArraySection;
	function [PASS_WRITE] [PASS_DOWN] [ENTITY_DECL] = (PtFrN) write_EntityDecl;
	function [PASS_WRITE] [PASS_DOWN] [DUM_LIST] = (PtFrN) write_DumList;
	function [PASS_WRITE] [PASS_DOWN] [OPEN_STMT] = (PtFrN) write_OpenStmt;
	function [PASS_WRITE] [PASS_DOWN] [CLOSE_STMT] = (PtFrN) write_CloseStmt;
	function [PASS_WRITE] [PASS_DOWN] [WRITE_STMT] = (PtFrN) write_WriteStmt;
	function [PASS_WRITE] [PASS_DOWN] [PRINT_STMT] = (PtFrN) write_PrintStmt;
	function [PASS_WRITE] [PASS_DOWN] [READ_STMT] = (PtFrN) write_ReadStmt;
	function [PASS_WRITE] [PASS_DOWN] [BACKSPACE_STMT] = (PtFrN) write_BackspaceStmt;
	function [PASS_WRITE] [PASS_DOWN] [END_FILE_STMT] = (PtFrN) write_EndFileStmt;
	function [PASS_WRITE] [PASS_DOWN] [REWIND_STMT] = (PtFrN) write_RewindStmt;
	function [PASS_WRITE] [PASS_DOWN] [INQUIRE_STMT] = (PtFrN) write_InquireStmt;
	function [PASS_WRITE] [PASS_DOWN] [STOP_STMT] = (PtFrN) write_StopStmt;

	function [PASS_WRITE] [PASS_DOWN] [END_STMT] = (PtFrN) write_EndStmt;
	function [PASS_WRITE] [PASS_DOWN] [END_PROGRAM_STMT] = (PtFrN) write_EndStmt;
	function [PASS_WRITE] [PASS_DOWN] [END_SUBROUTINE_STMT] = (PtFrN) write_EndStmt;
	function [PASS_WRITE] [PASS_DOWN] [END_FUNCTION_STMT] = (PtFrN) write_EndStmt;
	function [PASS_WRITE] [PASS_DOWN] [END_BLOCK_DATA_STMT] = (PtFrN) write_EndStmt;

	function [PASS_WRITE] [PASS_DOWN] [DO_CONSTRUCT] = (PtFrN) write_DoConstruct;
	function [PASS_WRITE] [PASS_DOWN] [DO_STMT] = (PtFrN) write_DoStmt;
	function [PASS_WRITE] [PASS_DOWN] [EXIT_STMT] = (PtFrN) write_ExitStmt;
	function [PASS_WRITE] [PASS_DOWN] [CYCLE_STMT] = (PtFrN) write_CycleStmt;

	function [PASS_WRITE] [PASS_DOWN] [CASE_CONSTRUCT] = (PtFrN) write_CaseConstruct;

	function [PASS_WRITE] [PASS_DOWN] [DUM_EXPR] = (PtFrN) write_DumExpr;
	function [PASS_WRITE] [PASS_DOWN] [COMPLEX_LITERAL_CONSTANT] = (PtFrN) write_ComplexLiteralConstant;
}


comm_pass_init  ()
{
/* function[PASS_COMM][PASS_DOWN][ASSIGNEMENT_STMT] = (PtFrN)comm_AssignementStmt; */
 function[PASS_COMM][PASS_DOWN][FORALL_STMT] = (PtFrN)comm_ForallStmt;
}
